var FEbayFrame = null;

function TeBayInPageFrame() {
    return this;
}

TeBayInPageFrame.prototype =
{
    eBayPrefManager: null,
    id: null,
    keyword: null,
    display: true,
    maximized: false,
    showInRightCorner: false,
    Element: null,
    paramsToHideTabs: "",
    
    init: function(iId, iKeyword) {
        try {
            
            FEbayFrame = this;
            this.id = iId;
            this.keyword = iKeyword;
            this.eBayPrefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
        
        }catch(e) {/* alert(e);*/}
    },

    isLoaded: function(doc)  {
        return (doc.getElementById("eBayInPageMainDiv") != null);
    },

    displayEbayResultsOnTop: function(element, ParamsToHideTabs) {
        this.showInRightCorner = false;
        this.paramsToHideTabs = ParamsToHideTabs;
        this.inserteBayResultsTop(element, this.geteBayInPageUrl(this.keyword));
    },

    displayEbayResultsInRightCorner: function(element, ParamsToHideTabs) {
        this.showInRightCorner = true;
        this.paramsToHideTabs = ParamsToHideTabs;
        this.inserteBayResultsRightCorner(element, this.geteBayInPageUrl(this.keyword)); 
    },

    getHeight: function() {
        if (this.maximized) {
            return 520;
        } else {
            return 300;
        }
    },

    inserteBayResultsRightCorner: function(element, url) {
        try
        {
            this.Element = element;

            var MainDiv = this.Element.createElement("DIV");
            MainDiv.setAttribute("id", "eBayInPageMainDiv");
            MainDiv.setAttribute("style", "z-index:999;border:0px;position:fixed;width:500px;height:0px;right:0px;visibility:hidden");

            var frame = this.createEBayInPageFrame(MainDiv, url);
            MainDiv.appendChild(frame);
            element.body.appendChild(MainDiv);
        
        }catch(ex) {
          //  alert(ex);
        }
    },
    
    inserteBayResultsTop: function(element, url) {
        try
        {
            this.Element = element;
            var doc = this.Element;
            var MainDiv = element.createElement("DIV");
            MainDiv.setAttribute("id", "eBayInPageMainDiv");
            MainDiv.setAttribute("style", "position:relative; z-index:999;border:0px;width:100%;height:0px;left:0px;visibility:hidden");
               
            // Frame in der Seite einfgen
            var frame = this.createEBayInPageFrame(MainDiv, url);
            MainDiv.appendChild(frame);
            element.body.insertBefore(MainDiv, element.body.firstChild);
        }catch(ex) {
//            alert(ex);
        }
        
        return false;
    },

    addButtons: function(doc, frame) {
        var body2 = doc.body;
        var body = frame.contentDocument.body;
        if (this.showInRightCorner) {
            this.AddeBayInPageCloseButton(body, 5, 0);
            this.AddeBayInPagePrefButton(body, 29, 0);
            this.AddeBayInPageResizeButton(body, 53, 0);        
       } else {
            this.AddeBayInPageCloseButton(body, 5, 0);
            this.AddeBayInPagePrefButton(body, 29, 0);
            this.AddeBayInPageResizeButton(body, 53, 0);        
        }
        return body2;
    },

    removeButtons: function(doc) {
        var button = doc.getElementById("eBayInPageBtnResize");
        if (button){
            doc.body.removeChild(button);
        }
        button = doc.getElementById("eBayInPageBtnClose");
        if (button){
            doc.body.removeChild(button);
        }
        button = doc.getElementById("eBayInPageBtnPref");
        if (button){
            doc.body.removeChild(button);
        }
    },

    createEBayInPageFrame: function(MainDiv, url) {
        // Frame erzeugen
        var frame = this.Element.createElement("IFRAME");
        frame.setAttribute("id", "eBayInPageResultFrame");
        frame.setAttribute("src", url);
        frame.setAttribute("style", "position:relative;top:0px;left:0px;z-index:500;border-width:0px; margin:0px;background:white;width:100%;height:100%;");

        try
        {
            if (frame.addEventListener)
            {
                frame.addEventListener("load",  function() {FEbayFrame.onLoadFrame(frame, MainDiv);}, false);
            }
        }
	catch(ex)
	{
            this.onLoadFrame(frame, MainDiv);
	}
        return frame;
    },
    
    resizeFrameAndContent: function() {
        var doc     = this.Element; 
        var frame   = doc.getElementById("eBayInPageResultFrame");
        var MainDiv = doc.getElementById("eBayInPageMainDiv");
        if (frame) {
            var results = frame.contentDocument.getElementById("results");
            var newHeight = this.getHeight();
            if (results != null) {
                    results.style.height = newHeight - 70 + "px";
                    MainDiv.style.height = newHeight + "px";
                    MainDiv.style.visibility = "visible";
                    frame.style.height =  newHeight + "px";
                    if (this.showInRightCorner) {
                        MainDiv.style.bottom = -25 + "px";
                    }
            }
        }
    },
    
    onLoadFrame: function(frame, div) {
        this.resizeFrameAndContent();

        var doc = this.Element;
        var button =  doc.getElementById("eBayInPageBtnPref");
        if (button == null) {
            div.insertBefore(this.addButtons(doc, frame), frame);
        }

    },

    geteBayInPageUrl: function(keyword) {
        var s = keyword;
        s = s.replace(/^(\&|!|@|\*|\(|\)|\{|\}|,|\.|'|:|;|\?|\[|\])+/, "");
        s = s.replace(/(\&|!|@|\*|\(|\)|\{|\}|,|\.|'|:|;|\?|\[|\])+$/, "");
        s = s.replace(/ /g,"%20");
        var sid = this.eBayPrefManager.getIntPref("extensions.home_extension.eBaySID");
        var amazonCountry = this.eBayPrefManager.getCharPref("extensions.home_extension.AmazonCountry");
        var sdcCountry = this.eBayPrefManager.getCharPref("extensions.home_extension.SDCCountry");
        var URL;
        if (this.showInRightCorner) {
            URL =   "http://www.buyertools.net/quicksearch_extension/new2/de/indexUnten.php?w=ebayresult&sid=" + sid + "&amazoncountry=" + amazonCountry + "&shoppingcountry=" + sdcCountry + "&qry=" + s;
        } else {
            URL =   "http://www.buyertools.net/quicksearch_extension/new2/de/index.php?w=ebayresult&sid=" + sid +  "&amazoncountry=" + amazonCountry + "&shoppingcountry=" + sdcCountry +"&qry=" + s;

        }
        if (this.paramsToHideTabs != "") {
            URL = URL +  "&" + this.paramsToHideTabs;
        }
        return URL;
    },
   
    AddeBayInPagePrefButton: function(MainDiv, buttonRightPos, buttonTopPos)
    {
        var btnClose = this.Element.createElement("input");
        btnClose.id = "eBayInPageBtnPref";
        btnClose.type = "image";
        btnClose.src = "http://www.buyertools.net/quicksearch_extension/bilder/extension/einstellungen.gif";
        btnClose.alt = "Einstellungen";
        btnClose.style.height = "24px";
        btnClose.style.width = "24px";
        btnClose.style.position = "absolute";
        btnClose.style.right = buttonRightPos + "px";
        btnClose.style.top = buttonTopPos + "px";
        btnClose.addEventListener("click", function () { eBayInPage_OpenPref();}, false);
        MainDiv.appendChild(btnClose);
    },

    AddeBayInPageCloseButton: function(MainDiv, buttonRightPos, buttonTopPos)
    {
        var btnClose = this.Element.createElement("input");
        btnClose.id = "eBayInPageBtnClose";
        btnClose.type = "image";
        btnClose.src = "http://www.buyertools.net/quicksearch_extension/bilder/extension/btnclose.gif";
        btnClose.alt = "Schliessen";
        btnClose.style.height = "24px";
        btnClose.style.width = "24px";
        btnClose.style.position = "absolute";
        btnClose.style.right = buttonRightPos + "px";
        btnClose.style.top = buttonTopPos + "px";
        btnClose.addEventListener("click", function () { FEbayFrame.eBayInPageRemoveExistingFrame();}, false);
        MainDiv.appendChild(btnClose);
    },

    AddeBayInPageResizeButton: function(MainDiv, buttonRightPos, buttonTopPos)
    {
        
        var btnClose = this.Element.createElement("input");
        btnClose.id = "eBayInPageBtnResize";
        btnClose.type = "image";
    
        if (this.maximized) {
            btnClose.src = "http://www.buyertools.net/quicksearch_extension/bilder/extension/minimieren.gif";
        } else {
            btnClose.src = "http://www.buyertools.net/quicksearch_extension/bilder/extension/maximieren.gif";
        }
        btnClose.alt = "Minimieren/Maximieren";
        btnClose.style.height = "24px";
        btnClose.style.width = "24px";
        btnClose.style.position = "absolute";
        btnClose.style.right = buttonRightPos + "px";
        btnClose.style.top = buttonTopPos + "px";
        btnClose.addEventListener("click", function () {FEbayFrame.eBayInPageResize(); }, false);
        MainDiv.appendChild(btnClose);
    },

    eBayInPageResize: function() {
        try {
            this.maximized = !this.maximized;

            var doc = this.Element;
            var frame = doc.getElementById("eBayInPageResultFrame");
            doc = frame.contentDocument; 
            var btnResize = doc.getElementById("eBayInPageBtnResize");

            if (this.maximized) {
                btnResize.src = "http://www.buyertools.net/quicksearch_extension/bilder/extension/minimieren.gif";
            } else {
                btnResize.src = "http://www.buyertools.net/quicksearch_extension/bilder/extension/maximieren.gif";
            }

            if (this.showInRightCorner) {
               this.resizeFrameAndContent(); 
            } else {
               this.resizeFrameAndContent(); 
            }
        }catch(ex)  {
//            alert(ex);
        }
    },

    eBayInPageRemoveExistingFrame: function() {
        this.display = false;
        var doc = this.Element;
        var MainDiv = doc.getElementById("eBayInPageMainDiv");
        if (MainDiv != null)
        {
            doc.body.removeChild(MainDiv);
        }
        this.removeButtons(doc);
    }
}
